// SetupDlg.cpp 
//

#include "stdafx.h"
#include "DS102.h"
#include "SetupDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSetupDlg 


CSetupDlg::CSetupDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSetupDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSetupDlg)
	m_iLSpeed = 0;
	m_iRate = 0;
	m_dResolution = 0.0;
	//}}AFX_DATA_INIT
}


void CSetupDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSetupDlg)
	DDX_Control(pDX, IDC_ORG, m_cmbORG);
	DDX_Control(pDX, IDC_UNIT, m_cmbUnit);
	DDX_Text(pDX, IDC_LSPEED, m_iLSpeed);
	DDV_MinMaxInt(pDX, m_iLSpeed, 1, 9999);
	DDX_Text(pDX, IDC_RATE, m_iRate);
	DDV_MinMaxInt(pDX, m_iRate, 1, 9999);
	DDX_Text(pDX, IDC_RESOLUTION, m_dResolution);
	DDV_MinMaxDouble(pDX, m_dResolution, 1.e-007, 99999999.);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSetupDlg, CDialog)
	//{{AFX_MSG_MAP(CSetupDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSetupDlg  

BOOL CSetupDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// 
	
	CString strMessage;
	pMain = (CDS102Dlg*)AfxGetMainWnd();		// Get pointer of mainwindow

	// Initial velocity (L) is acquired.
	strMessage.Format("LSpeed%d?",iAxisNumber);
	pMain->Send(strMessage);
	pMain->Receive(strMessage);
	m_iLSpeed = atoi(strMessage);
	
	// An acceleration-slowdown rate (R) is obtained.
	strMessage.Format("Rate%d?",iAxisNumber);
	pMain->Send(strMessage);
	pMain->Receive(strMessage);
	m_iRate = atoi(strMessage);

	// The memory switch 0 (origin pattern) is obtained.
	strMessage.Format("Axi%d:memsw0?",iAxisNumber);
	pMain->Send(strMessage);
	pMain->Receive(strMessage);
	m_cmbORG.SetCurSel(atoi(strMessage));

	// UNIT (unit to display) is obtained.
	strMessage.Format("Axi%d:Unit?",iAxisNumber);
	pMain->Send(strMessage);
	pMain->Receive(strMessage);
	m_cmbUnit.SetCurSel(atoi(strMessage));

	// Basic resolution is obtained.
	strMessage.Format("axi%d:standard?",iAxisNumber);
	pMain->Send(strMessage);
	pMain->Receive(strMessage);
	m_dResolution = atof(strMessage);

	// The memory switch 1 (machine limit input logic) is obtained.
	strMessage.Format("axi%d:memsw1?",iAxisNumber);
	pMain->Send(strMessage);
	pMain->Receive(strMessage);
	if (atoi(strMessage) == 0) ((CButton*)GetDlgItem(IDC_LSNC))->SetCheck(1);
	else					   ((CButton*)GetDlgItem(IDC_LSNO))->SetCheck(1);

	// The memory switch 2 (origin sensor input logic) is obtained.
	strMessage.Format("axi%d:memsw2?",iAxisNumber);
	pMain->Send(strMessage);
	pMain->Receive(strMessage);
	if (atoi(strMessage) == 0) ((CButton*)GetDlgItem(IDC_ONC))->SetCheck(1);
	else					   ((CButton*)GetDlgItem(IDC_ONO))->SetCheck(1);

	// The memory switch 3 (proximity origin sensor input logic) is obtained.
	strMessage.Format("axi%d:memsw3?",iAxisNumber);
	pMain->Send(strMessage);
	pMain->Receive(strMessage);
	if (atoi(strMessage) == 0) ((CButton*)GetDlgItem(IDC_NONC))->SetCheck(1);
	else					   ((CButton*)GetDlgItem(IDC_NONO))->SetCheck(1);

	// The memory switch 4 (current down control) is obtained.
	strMessage.Format("axi%d:memsw4?",iAxisNumber);
	pMain->Send(strMessage);
	pMain->Receive(strMessage);
	if (atoi(strMessage) == 0) ((CButton*)GetDlgItem(IDC_CDON))->SetCheck(1);
	else					   ((CButton*)GetDlgItem(IDC_CDOFF))->SetCheck(1);

	// The memory switch 5 (the direction of move) is obtained.
	strMessage.Format("axi%d:memsw5?",iAxisNumber);
	pMain->Send(strMessage);
	pMain->Receive(strMessage);
	if (atoi(strMessage) == 0) ((CButton*)GetDlgItem(IDC_PULS))->SetCheck(1);
	else					   ((CButton*)GetDlgItem(IDC_MINUS))->SetCheck(1);

	// The number of micro step division is obtained. (When you set less than to 1/2 in D220 series, please change into a combo box etc.)
	strMessage.Format("axi%d:drdiv?",iAxisNumber);
	pMain->Send(strMessage);
	pMain->Receive(strMessage);
	if (atoi(strMessage) == 0) ((CButton*)GetDlgItem(IDC_FULL))->SetCheck(1);
	else					   ((CButton*)GetDlgItem(IDC_HALF))->SetCheck(1);

	UpdateData(FALSE);

	return TRUE;  // 
	              // 
}

void CSetupDlg::OnOK() 
{
	// 
	
	if (UpdateData(TRUE) == FALSE) return;

	CString strMessage;
	
	// Initial velocity is set up.
	strMessage.Format("lspeed%d %d",iAxisNumber,m_iLSpeed);
	pMain->Send(strMessage);
	
	// An acceleration-slowdown rate (R) is set up.
	strMessage.Format("rate%d %d",iAxisNumber,m_iRate);
	pMain->Send(strMessage);

	// The memory switch 0 (origin pattern) is set up.
	strMessage.Format("Axi%d:memsw0 %d",iAxisNumber,m_cmbORG.GetCurSel());
	pMain->Send(strMessage);

	// UNIT (unit to display) is set up.
	strMessage.Format("Axi%d:unit %d",iAxisNumber,m_cmbUnit.GetCurSel());
	pMain->Send(strMessage);

	// Basic resolution is set up.
	strMessage.Format("Axi%d:standard %9f",iAxisNumber,m_dResolution);
	pMain->Send(strMessage);

	// The memory switch 1 (machine limit input logic) is set up.
	strMessage.Format("Axi%d:memsw1 %d",iAxisNumber,((CButton*)GetDlgItem(IDC_LSNO))->GetCheck());
	pMain->Send(strMessage);

	// The memory switch 2 (origin sensor input logic) is set up.
	strMessage.Format("Axi%d:memsw2 %d",iAxisNumber,((CButton*)GetDlgItem(IDC_ONO))->GetCheck());
	pMain->Send(strMessage);

	// The memory switch 3 (proximity origin sensor input logic) is set up.
	strMessage.Format("Axi%d:memsw3 %d",iAxisNumber,((CButton*)GetDlgItem(IDC_NONO))->GetCheck());
	pMain->Send(strMessage);

	// The memory switch 4 (current down control) is set up.
	strMessage.Format("Axi%d:memsw4 %d",iAxisNumber,((CButton*)GetDlgItem(IDC_CDOFF))->GetCheck());
	pMain->Send(strMessage);

	// The memory switch 5 (the direction of move) is set up.
	strMessage.Format("Axi%d:memsw5 %d",iAxisNumber,((CButton*)GetDlgItem(IDC_MINUS))->GetCheck());
	pMain->Send(strMessage);

	// The number of micro step division is obtained. (When you set less than to 1/2 in DS102 series, please change into a combo box etc.)
	strMessage.Format("Axi%d:drdiv %d",iAxisNumber,((CButton*)GetDlgItem(IDC_HALF))->GetCheck());	
	pMain->Send(strMessage);

	CDialog::OnOK();
}

void CSetupDlg::OnCancel() 
{
	// 
	
	CDialog::OnCancel();
}
